/* draw.h */
#ifndef _DRAW_H_
#define _DRAW_H_

/*   */
#include <windows.h>

/*    */
#define SWERVES_COUNT               4
/*    */
#define BALL_COUNT                  3
/*    */
#define SLIVERS_COUNT               9

/*    */
#define BACKGROUND_0                0
#define BACKGROUND_1                1
#define BACKGROUND_2                2
#define BACKGROUND_3                3

/*     */
#define PICTURE_SWERVE_OFF          0        /*  */
#define PICTURE_SWERVE_ON           1        /*  */

/*    */
#define SHOW_ALIEN_BIRD             1        /*  */
#define SHOW_ALIEN_UFO              2        /*  */

/*   */
#define TYPE_RACKET_NORMAL          0        /*   */
#define TYPE_RACKET_GUN             1        /*   */
#define TYPE_RACKET_EXTEND          2        /*   */

#define TYPE_RACKET_N_G_1           3        /*      */
#define TYPE_RACKET_N_G_2           4        /* normal -> gun */
#define TYPE_RACKET_N_G_3           5        /* normal -> gun */
#define TYPE_RACKET_N_G_4           6        /* normal -> gun */

#define TYPE_RACKET_N_E_1           7        /*      */
#define TYPE_RACKET_N_E_2           8        /* normal -> extend */
#define TYPE_RACKET_N_E_3           9        /* normal -> extend */
#define TYPE_RACKET_N_E_4          10        /* normal -> extend */
#define TYPE_RACKET_N_E_5          11        /* normal -> extend */
#define TYPE_RACKET_N_E_6          12        /* normal -> extend */
#define TYPE_RACKET_N_E_7          13        /* normal -> extend */

/*   */
#define BONUS_POINTS                0
#define BONUS_SMART_BOMB            1
#define BONUS_EXTRA_LIFE            2
#define BONUS_SLOW_BALL             3
#define BONUS_SMASH_BALL            4
#define BONUS_TRIPLE_BALL           5
#define BONUS_HAND                  6
#define BONUS_GUN                   7
#define BONUS_EXTENDED_RACKET       8
#define BONUS_ROCKET_PACK           9
#define BONUS_400_POINTS           10

/*       () */
#define TYPE_ALIEN_0                0
#define TYPE_ALIEN_1                1
#define TYPE_ALIEN_2                2
#define TYPE_ALIEN_3                3
#define TYPE_ALIEN_4                4

/*       () */
#define TYPE_UFO_0                  0
#define TYPE_UFO_1                  1
#define TYPE_UFO_2                  2
#define TYPE_UFO_3                  3
#define TYPE_UFO_4                  4
#define TYPE_UFO_5                  5

/*        */
#define TYPE_BANG_0                 0
#define TYPE_BANG_1                 1
#define TYPE_BANG_2                 2
#define TYPE_BANG_3                 3
#define TYPE_BANG_4                 4

/*       */
#define TYPE_SLIVER_0               0
#define TYPE_SLIVER_1               1
#define TYPE_SLIVER_2               2
#define TYPE_SLIVER_3               3
#define TYPE_SLIVER_4               4

/*    */
#define MESSAGE_ROUND               1
#define MESSAGE_PAUSE               2

/*    */
typedef struct _PICTURE {
	int show;                          /*   */
	int type;                          /*   */
	int X,Y;                           /*  */
} PICTURE, *LPPICTURE;

/*    */
typedef struct _FULL_PICTURE {
	PICTURE picture;                   /*  */
	PICTURE shadow;                    /*    */
} FULL_PICTURE, *LPFULL_PICTURE;

/*     */
typedef struct _MESSAGE {
	int show;                          /*   */
	int flags;                         /*    */
	int player;                        /*   */
	int round;                         /*   */
	int pause;                         /*  */
} MESSAGE, *LPMESSAGE;

/*     */
typedef struct _SLIVERS{
	int show;                               /*   */
	FULL_PICTURE picture[SLIVERS_COUNT];    /*   */
} SLIVERS, *LPSLIVERS;

/*     */
typedef struct _SCENE {
	int on;                            /*    */
	int background;                    /*  */
	UCHAR block[12][15];               /*   */
	PICTURE pRacket;                   /*  */
	PICTURE pAlien;                    /*   */
	PICTURE pBang;                     /*  */
	PICTURE pBonus;                    /*  */
	PICTURE pSwerves[SWERVES_COUNT];   /*   */
	FULL_PICTURE pBomb;                /*  */
	FULL_PICTURE pBall[BALL_COUNT];    /*  */
	SLIVERS pSlivers;                  /*   */
	MESSAGE message;                   /*  */
} SCENE, *LPSCENE;

/*     */
int InitDraw(void);
/*     */
void ReleaseDraw(void);

/*   */
int CreateScene(void);
/*    */
int DrawScene(void);
/*   */
void ReleaseScene(void);

/*   */
extern SCENE scene;

#endif  /* _DRAW_H_ */
